
// test signedness of bitfields (implementation defined)
// try: gcc -funsigned-bitfields

#include <stdio.h>

#define DEF(T,x) T x;                   \
    void print_def_##x(void) {          \
        printf(#T " " #x ";\n");        \
        printf("sizeof(" #x ") = %zd\n", sizeof(x)); \
    }

DEF(struct T {
    unsigned a:1;
    int      b:1;
    unsigned c:6;
    int      d:6;
    int :0;
    unsigned m:23;
    unsigned e:8;
    int      s:1;
    long long l:53;
}, t)

#define TEST(field,x) do {      \
    field = x;                  \
    printf(#field " = " #x "; \t// value: %2lld\n",  \
                          (long long)field);        \
    }while(0)

int main() {
    print_def_t();
    TEST(t.a,1);
    TEST(t.b,1);
    TEST(t.c,-1);
    TEST(t.d,-1);

    TEST(t.m,-1);
    TEST(t.e,128);
    TEST(t.s,0);

    TEST(t.l,1234567890123456LL);      // fits into 53 bits
    TEST(t.l,123456789012345678LL);    // warning expected (truncation)
    return 0;
}
